/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rest.korisnik;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.GenericEntity;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import model.Korisnik;

/**
 *
 * @author student
 */
@Stateless
@Path("korisnik")
public class KorisnikRest {

    @PersistenceContext(unitName = "RestServisiPU")
    private EntityManager em;

    @POST
    @Path("login")
    @Consumes(MediaType.APPLICATION_XML)
    @Produces(MediaType.APPLICATION_XML)
    public Response login(Korisnik k) {
        Korisnik korisnik = em.find(Korisnik.class, k.getKorisnickoime());
        if (korisnik != null && korisnik.getKorisnickasifra().equals(k.getKorisnickasifra())) {
            return Response.ok(korisnik).build();
        }
        return Response.status(Response.Status.NOT_FOUND).build();
    }

    @GET
    @Path("vrati_detalje/{username}")
    @Produces(MediaType.APPLICATION_XML)
    public Response vratiDetalje(@PathParam("username") String username) {
        Korisnik k = em.find(Korisnik.class, username);
        if (k != null) {
            return Response.ok(k).build();
        }
        return Response.status(Response.Status.NOT_FOUND).build();
    }

    @GET
    @Path("vrati_korisnike")
    @Produces(MediaType.APPLICATION_XML)
    public Response vratiSveKorisnike() {
        List<Korisnik> lk = em.createQuery("SELECT k FROM Korisnik k").getResultList();
        GenericEntity<List<Korisnik>> ge = new GenericEntity<List<Korisnik>>(lk) {
        };
        return Response.ok(ge).build();
    }

}
